var expect = require('chai').expect;
var Turret = require('../public/things').Turret;
var AlienShip = require('../public/things').AlienShip;
var Missile = require('../public/things').Missile;

describe('things-tests', function() {
  
  //Exercise 1: We will make sure all things are setup and ready for us in 
  //this exercise.
  
  //On the command line, type the command
  // npm install
  //after it completes, type 
  // npm test
  //you will notice it reports several tests pending.
  //Change the word "xit" to "it" in the first test below, save the file and 
  //make sure the test passes. If that works, you are done with exercise 1.
  //If it does not work, please ask for help.
  describe('exercise 1', function() {        
    xit('canary test to check if things are installed and ready', function() {
      expect(true).to.be.true;
    });
  });
            
  //Exercise 2: Change only one "xit" to "it" in this test group.
  //Save the file after the change, see the test fail. Then write minimum code
  //in the file public/things.js to make the test pass. Then work on the next
  //test. Work your way to make each of the test (one at a time) in this test 
  //group to pass.
  describe('exercise 2', function() {
    xit('base of the turret is 30', function() {
      var turret = new Turret();
      
      expect(turret.base).to.be.eql(30);
    });

    xit('height of the turret is 10', function() {
      var turret = new Turret();
      
      expect(turret.height).to.be.eql(10);
    });

    //Once you have all the above tests passing, you are ready to see the
    //turret, this is where you will be monitoring the alien ships from.
    
    //On the command prompt, type 
    // npm start
    //The open your browser and go to http://localhost:8080
    //You should see the turret being drawn
  });

  describe('exercise 3', function() {
    var ship;
    
    beforeEach(function() {
      ship = new AlienShip();
    });
    
    xit('radius of alien ship should be 20', function() {
      expect(ship.radius).to.be.eql(20);
    });

    xit('x position of alien ship should be 20', function() {
      expect(ship.x).to.be.eql(20);
    });

    xit('y position of alien ship should be 30', function() {
      expect(ship.y).to.be.eql(30);
    });

    xit('displacement of alien ship should be 2', function() {
      expect(ship.displacement).to.be.eql(2);
    });                                      
    
    xit('move increases the x position of ship by displacement', function() {
      var x = ship.x;
      var displacement = ship.displacement;    
      
      ship.move();
      
      expect(ship.x).to.be.eql(x + displacement);
    });
    
    xit('move returns true after a successful move', function() {
      expect(ship.move()).to.be.true;
    });

    xit('move returns false if x position is greater than 500', function() {
      ship.x = 499;
      expect(ship.move()).to.be.false;
    });

    //Once you have all the above tests passing, you are ready to see the
    //alien ship!
    
    //On the command prompt, type 
    // npm start
    //The open your browser and go to http://localhost:8080
    //You should see the alien ship fly from left to right
  });

  describe('exercise 4', function() {
    var missile;
    
    beforeEach(function() {
      missile = new Missile(220, 100);
    });
    
    xit('x for the missile is set through the constructor', function() {
      expect(missile.x).to.be.eql(220);
    });

    xit('initial y for the missile is set through the constructor', function() {
      expect(missile.y).to.be.eql(100);
    });

    xit('displacement of missile should be 5', function() {
      expect(missile.displacement).to.be.eql(5);
    });                                      
    
    xit('move decreases y position of missile by displacement', function() {
      var y = missile.y;
      var displacement = missile.displacement;    
      
      missile.move();
      
      expect(missile.y).to.be.eql(y - displacement);
    });
    
    xit('move returns true after a successful move', function() {
      expect(missile.move()).to.be.true;
    });
    
    xit('move returns false if y position is less than 0', function() {
      missile.y = 2;
      expect(missile.move()).to.be.false;
    });

    //Once you have all the above tests passing, you are ready to see the
    //missile being fired
    
    //On the command prompt, type 
    // npm start
    //The open your browser and go to http://localhost:8080
    //You should see the alien ship fly and missile go at it
  });
  
  describe('exercise 5', function() {
    var ship;
    var missile;
    
    beforeEach(function() {
      ship = new AlienShip();
      ship.x = 100;
      ship.y = 200;
      ship.radius = 50;
      
      missile = new Missile(0, 0);
    });

    xit('alien ship not hit by missle that is far away', function() {
      expect(ship.isHit(missile)).to.be.false;
    });

    xit('alien ship not hit by missle that is below it', function() {
      missile.x = ship.x;
      missile.y = ship.y + ship.radius + 10;
      expect(ship.isHit(missile)).to.be.false;
    });

    xit('alien ship not hit by missle that is above it', function() {
      missile.x = ship.x;
      missile.y = ship.y - ship.radius - 10;
      expect(ship.isHit(missile)).to.be.false;
    });

    xit('alien ship not hit by missle that is to its right', function() {
      missile.x = ship.x + ship.radius + 10;
      missile.y = ship.y;
      expect(ship.isHit(missile)).to.be.false;
    });

    xit('alien ship not hit by missle that is to its left', function() {
      missile.x = ship.x - ship.radius - 10;
      missile.y = ship.y;
      expect(ship.isHit(missile)).to.be.false;
    });

    xit('alien ship hit by missle at the center', function() {
      missile.x = ship.x;
      missile.y = ship.y;
      expect(ship.isHit(missile)).to.be.true;
    });

    xit('alien ship hit by missle a little below the center', function() {
      missile.x = ship.x;
      missile.y = ship.y + (ship.radius / 2);
      expect(ship.isHit(missile)).to.be.true;
    });

    xit('alien ship hit by missle that touches it', function() {
      missile.x = ship.x;
      missile.y = ship.y + ship.radius;
      expect(ship.isHit(missile)).to.be.true;
    });

    //Once you have all the above tests passing, you are ready to see the
    //missile hit the alien ship
    
    //On the command prompt, type 
    // npm start
    //The open your browser and go to http://localhost:8080
    //You should see the alien ship fly, missile go up, and hit the alien ship
  });
});
